/* A run program for Fvwm95 and the Xclass set. */
/* Written by Frank Hall. April 4, 1997 */
/* Modified May 14, 1997 to incorporate new OXFileDialog */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <X11/keysym.h>
#include <xclass/OXClient.h>
#include <xclass/OXWindow.h>
#include <xclass/OXFrame.h>
#include <xclass/OXWidgets.h>
#include <xclass/OXMsgBox.h>
#include <xclass/OString.h>
#include <xclass/OMimeTypes.h>
#include <xclass/OXFileDialog.h>
#include <xclass/utils.h>
#include <unistd.h>

/* Modify these for what you need. In the future they will hopefully be determined automatically. */

#define PixmapPath "./"

/* The rest should should hopefully be ok. */

#define MaxArgs          10

#define OKButtonID       1
#define CancelButtonID   2

OMimeTypes *MimeTypeList;

char *filetypes[] = { "All Files", "*", NULL, NULL };

class QuitFrame : public OXMainFrame
{
public:
	QuitFrame(const OXWindow *p, int w, int h, unsigned long options);
	virtual ~QuitFrame();
	virtual int ProcessMessage(long msg, long parm1, long parm2);

protected:
	OXCompositeFrame *DescriptionFrame;
	OXCompositeFrame *TextFrame;
	OXCompositeFrame *ButtonFrame;

	OXLabel *Description;
	OString *DescriptionText;
	OXIcon *DescriptionIcon;

	OXLabel *OpenLabel;
	OString *OpenText;

	const OPicture *IconPicture;

	OXRadioButton *Halt,*Restart,*Logout;
	OXTextButton *OKButton;
	OXTextButton *CancelButton;
};




OXClient *ClientX;
OPicturePool *Pictures;
QuitFrame *MainWindow;

main()
{
	char mimerc[PATH_MAX];

			/* Create Client */
	ClientX = new OXClient;

			/* Open Up Picture Pool */
	Pictures = new OPicturePool(ClientX,PixmapPath);

			/* Get location of .mime.types file */
	sprintf(mimerc, "%s/.mime.types", getenv("HOME"));

			/* Initialize mime type list for browse option */
	MimeTypeList = new OMimeTypes(ClientX, mimerc);

			/* Create Main Window */
	MainWindow  = new QuitFrame(ClientX->GetRoot(),250,115, MAIN_FRAME | VERTICAL_FRAME);

			/* Map The Main Window */
	MainWindow->MapWindow();

			/* Activate The Whole Thing */
	ClientX->Run();

}


QuitFrame::QuitFrame(const OXWindow *p, int w, int h,unsigned long options) : 
			      OXMainFrame(p, w, h, options)
{
	int dummy;
	unsigned int ScreenHeight, udummy;
	Window wdummy;

			/* Track Focus Changes */
	XSelectInput(GetDisplay(), _id, FocusChangeMask | ExposureMask |
					StructureNotifyMask);

			/* Create Frame To Hold Description */
	DescriptionFrame = new OXCompositeFrame(this, 60, 32, HORIZONTAL_FRAME);


			/* Get Picture From Pool */
	IconPicture = Pictures->GetPicture("quit.xpm");

			/* Create Icon */
	DescriptionIcon = new OXIcon(DescriptionFrame, IconPicture, 32, 32);

			/* Attach Icon To Description Frame */
	DescriptionFrame->AddFrame(DescriptionIcon, new OLayoutHints(LHINTS_LEFT,
5, 5, 5, 5));

			/* Create Text For Label */
	DescriptionText = new OString("Please select how you want to proceed:");

			/* Create Label */
	Description = new OXLabel(DescriptionFrame,DescriptionText);

			/* Attach Label To Description Frame */
	DescriptionFrame->AddFrame(Description, new OLayoutHints(LHINTS_LEFT
| LHINTS_CENTER_Y,
5, 5, 5, 5));

	/* Create Frame To Hold Text Box */
	TextFrame = new OXCompositeFrame(this, 60, 20, VERTICAL_FRAME);

	/* Create Frame To Hold Buttons */
	ButtonFrame = new OXCompositeFrame(this,60,20,HORIZONTAL_FRAME);
	/* Create Check Box */
	Halt = new OXRadioButton(TextFrame,new OHotString ("Quit Linux"), 101);
	Restart = new OXRadioButton(TextFrame, new OHotString ("Reboot Linux"),102);
	Logout = new  OXRadioButton(TextFrame, new OHotString ("Login under a different name"),103);
	/* Attach Check Box To Button Frame */
	TextFrame->AddFrame(Halt, new OLayoutHints(LHINTS_TOP | LHINTS_LEFT, 10, 5,0, 2));
	TextFrame->AddFrame(Restart, new OLayoutHints(LHINTS_TOP | LHINTS_LEFT, 10, 5,0,2));
	TextFrame->AddFrame(Logout, new OLayoutHints(LHINTS_TOP | LHINTS_LEFT, 10, 5,0, 2));
	Halt->Associate(this);
	Restart->Associate(this);
	Logout->Associate(this);
	Halt->SetState(BUTTON_DOWN);
	CancelButton = new OXTextButton(ButtonFrame,new OHotString(" Cancel "),CancelButtonID);
	CancelButton->Associate(this);
	ButtonFrame->AddFrame(CancelButton, new OLayoutHints(LHINTS_CENTER_Y | LHINTS_RIGHT, 5, 5, 5, 0));
	OKButton = new OXTextButton(ButtonFrame,new OHotString("    OK    "),OKButtonID);
	OKButton->Associate(this);
	ButtonFrame->AddFrame(OKButton, new OLayoutHints(LHINTS_CENTER_Y | LHINTS_RIGHT, 0, 5, 5,0));
	/* Attach Description Frame To Main Window */
	AddFrame(DescriptionFrame, new OLayoutHints(LHINTS_TOP, 0, 0, 1, 0));

			/* Attach Text Frame To Main Window */
	AddFrame(TextFrame, new OLayoutHints(LHINTS_TOP, 40, 0, 1, 0));

			/* Attach Button Frame To Main Window */
	AddFrame(ButtonFrame, new OLayoutHints(LHINTS_TOP | LHINTS_EXPAND_X, 0, 0, 5, 5));

			/* Set The Name Displayed In The Title Bar */
	SetWindowName("Quit");

			/* Set class name and resource names */
	SetClassHints("Quit", "Quit");

			/* Map All Sub Windows (And Frames) Of The Main Window */
	MapSubwindows();

			/* Set The Size Of The Main Window To Something Decent */
	Resize(GetDefaultWidth(),GetDefaultHeight());

	XGetGeometry(GetDisplay(), _client->GetRoot()->GetId(), &wdummy,
		&dummy, &dummy, &udummy, &ScreenHeight, &udummy, &udummy);

			/* Move to a decent position */
	Move(20, ScreenHeight - GetDefaultHeight() - 100);

			/* Tell the WM we want that position */
	SetWMPosition(20, ScreenHeight - GetDefaultHeight() - 100);

  ODimension size=GetDefaultSize();
  SetMWMHints(MWM_DECOR_ALL | MWM_DECOR_RESIZEH | MWM_DECOR_MAXIMIZE | MWM_DECOR_MINIMIZE | MWM_DECOR_MENU, MWM_FUNC_ALL | MWM_FUNC_RESIZE | MWM_FUNC_MAXIMIZE | MWM_FUNC_MINIMIZE, MWM_INPUT_MODELESS);
  SetWMSize(size.w,size.h);
  SetWMSizeHints(size.w, size.h, size.w, size.h, 0, 0);
  Layout();

}

QuitFrame::~QuitFrame()
{
	delete CancelButton;
	delete OKButton;

	_client->FreePicture(IconPicture);

	delete OpenLabel;

	delete DescriptionIcon;
	delete Description;

	delete ButtonFrame;
	delete TextFrame;
	delete DescriptionFrame;
}

int QuitFrame::ProcessMessage(long msg, long parm1, long parm2)
{
	int i, j, k, Slen;
	char errmsg[255];
	char P2Run[255];
	char *Parg[MaxArgs];
	char *c;
	char PDirectory[PATH_MAX];
	OFileInfo fi;

	switch(GET_MSG(msg))
	{
	    case XC_COMMAND:
		switch(GET_SUBMSG(msg))
		{
		    case CM_CHECKBUTTON:
	switch(parm1) {
			   case 101:
				Restart->SetState(BUTTON_UP);
				Logout->SetState(BUTTON_UP);
			   break;
			   case 102:
				Halt->SetState(BUTTON_UP);
				Logout->SetState(BUTTON_UP);
			   break;
			   case 103:
				Halt->SetState(BUTTON_UP);
				Restart->SetState(BUTTON_UP);
			   break;
	 	};
		break;
		    case CM_BUTTON:
			switch(parm1)
			{
			    case OKButtonID:
				if (Halt->GetState()==BUTTON_DOWN){popen("/sbin/shutdown -h now"," ");};				
				if (Restart->GetState()==BUTTON_DOWN){popen("/sbin/shutdown -f now"," ");};
				if (Logout->GetState()==BUTTON_DOWN){popen("killall fvwm95"," ");};
				CloseWindow();			
	break;
			    case CancelButtonID:
				CloseWindow();
				break;
			}
			break;
		}
		break;
	}
	return True;
}
